﻿-- Daily Tamer Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local ldbicon = ldb and LibStub("LibDBIcon-1.0", true)
local DailyTamerCheck_mainframe

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local LIGHT_BLUE  = "|cff00ddFF"
local ZONE_BLUE   = "|cff00aacc"
local GREY        = "|cff999999"
local COORD_GREY  = "|cffBBBBBB"
local GOLD        = "|cffffcc00"
local WHITE       = "|cffffffff"
local function AddColor(str,color)
 return color..str.."|r"
end

local EKK          = 0; -- eastern kingdoms, kalimdor frame
local ONC          = 1; -- outlands, northrend, cataclysm frame
local ABOUT        = 2; -- about frame

-- elite pets daily quest (quest log)
local ep_quest_index = -1
local ep_totalpets = 10
local ep_header = "elite pets"
local ep_quest_name = ""
local ep_quest_missing = AddColor(string.format(ITEM_MISSING,BATTLE_PET_SOURCE_2),LIGHT_RED)
-- elite pets quest objective indexes
local epspecial = "#elitepets#"
local kawi = 1
local gorespine = 2
local nono = 3
local greyhoof = 4
local luckyyi = 5
local tiun = 6
local kafi = 7
local dosryga = 8
local nitun = 9
local xia = 10
--

local satchels_table, -- mainframe table
      WEheader,WEtable  -- world events table
local tables = {} -- minor tamers tables
------- constants ------------------------------
local npcnamecolor = GREY
local zonecolor = ZONE_BLUE
local coordcolor = COORD_GREY
local levelcolor = WHITE
local mainframenpcnamecolor = GREY
local mainframezonecolor = GREY
local mainframecoordcolor = COORD_GREY

-- pet families icons
local pfme  = "|TInterface\\icons\\Icon_PetFamily_Mechanical:12|t"
local pfbe  = "|TInterface\\icons\\Icon_PetFamily_Beast:12|t"
local pfhu  = "|TInterface\\icons\\Icon_PetFamily_Humanoid:12|t"
local pfdr  = "|TInterface\\icons\\Icon_PetFamily_Dragon:12|t"
local pffl  = "|TInterface\\icons\\Icon_PetFamily_Flying:12|t"
local pfcr  = "|TInterface\\icons\\Icon_PetFamily_Critter:12|t"
local pfma  = "|TInterface\\icons\\Icon_PetFamily_Magical:12|t"
local pfun  = "|TInterface\\icons\\Icon_PetFamily_Undead:12|t"
local pfwa  = "|TInterface\\icons\\Icon_PetFamily_Water:12|t"
local pfel  = "|TInterface\\icons\\Icon_PetFamily_Elemental:12|t"

-- icons
local dtcicon = "Interface\\ICONS\\INV_MISC_PETMOONKINTA"
local icon_firespirit = "|TInterface\\icons\\INV_Pet_PandarenElemental_Fire:12|t "
local icon_waterspirit = "|TInterface\\icons\\Inv_pet_PandarenElemental:12|t "
local icon_earthspirit = "|TInterface\\icons\\INV_Pet_PandarenElemental_Earth:12|t "
local icon_airspirit = "|TInterface\\icons\\INV_Pet_PandarenElemental_Air:12|t "
-- buttons' textures
local tx_btnnorth     = "Interface\\icons\\Achievement_Zone_Northrend_01"
local tx_btnkalim     = "Interface\\icons\\Achievement_Zone_Kalimdor_01"
local tx_btnabout     = "Interface\\icons\\Icon_PetFamily_Beast"
local tx_chkcoords    = "Interface\\icons\\INV_Misc_Map_01"
local tx_chkminimap   = "Interface\\icons\\INV_Misc_Map03"
local tx_chknames     = "Interface\\icons\\Achievement_Character_Pandaren_Female"
local tx_chkicons     = "Interface\\icons\\Icon_PetFamily_Dragon"
local tx_chklevel     = "Interface\\icons\\INV_Pet_Achievement_RaiseAPetLevel_25"
local tx_optionsframe = "Interface\\icons\\Icon_PetFamily_Mechanical"

local opt_framespeed = 20  -- frames animation speed
local centerbuttons_spacing = 80
--local worldeventschecked = false

-- localization
local s_togglecoords
local s_togglenpcnames
local s_toggleminimapbtn
local s_togglenpclevel
local s_togglenpcicons
local s_optionsmain = COMPACT_UNIT_FRAME_PROFILE_SUBTYPE_ALL

 if GetLocale() == "itIT" then -- italian
  s_togglecoords = "Attiva coordinate"
  s_togglenpcnames = "Attiva nomi NPC"
  s_toggleminimapbtn = "Attiva pulsante minimappa"
  s_togglenpclevel = "Ordina i tamer per livello delle mascotte"
  s_togglenpcicons = "Attiva le icone delle mascotte dei tamer"
 else -- eng
  s_togglecoords = "Toggle coordinates"
  s_togglenpcnames = "Toggle NPC names"
  s_toggleminimapbtn = "Toggle minimap button"
  s_togglenpclevel = "Sort tamers by pet level"
  s_togglenpcicons = "Toggle pets' icons"
 end
--
 local coordinates = {     [32434] = " (57,42)",[32439] = " (61,88)",[32441] = " (65,94)",[32440] = " (29,36)",
            [31957] = " (55,38)",[31991] = " (36,52)",[31956] = " (36,74)",[31955] = " (46,44)",
            [31954] = " (62,45)",[31953] = " (48,54)",[31958] = " (68,41)",[31935] = " (77,20)",
            [31926] = " (31,42)",[31916] = " (40,77)",[31909] = " (66,65)",[31971] = " (57,42)",
            [31923] = " (17,50)",[31925] = " (59,70)",[31924] = " (61,49)",[31922] = " (64,49)",
            [31931] = " (29,34)",[31934] = " (13,67)",[31932] = " (50,59)",[31933] = " (59,77)",
            [31973] = " (50,57)",[31972] = " (61,33)",[31974] = " (57,57)",[31854] = " (20,29)",
            [31904] = " (39,79)",[31819] = " (58,53)",[31908] = " (46,60)",[31905] = " (53,74)",
            [31906] = " (32,33)",[31872] = " (57,45)",[31871] = " (60,50)",[31907] = " (40,56)",
            [31862] = " (59,71)",[31818] = " (44,28)",[31851] = " (51,73)",[31910] = " (62,54)",
            [31911] = " (67,54)",[31914] = " (25,47)",[31850] = " (20,44)",[31913] = " (76,41)",
            [31693] = " (42,84)",[31912] = " (35,27)",[31781] = " (33,52)",[31780] = " (61,19)",
            [31852] = " (46,40)",
            --elite pets
            [epspecial..kawi] = " (48,71)", [epspecial..gorespine] = " (26,50)",
            [epspecial..nono] = " (11,71)", [epspecial..greyhoof] = " (25,78)",
            [epspecial..luckyyi] = " (40,43)", [epspecial..tiun] = " (72,80)",
            [epspecial..kafi] = " (35,56)", [epspecial..dosryga] = " (68,85)",
            [epspecial..nitun] = " (57,29)", [epspecial..xia] = " (36,37)" }
            
------- localized zone and npc names from GetAchievementCriteriaInfo --------
local zones = {
     -- Pandaria --                       -- Cataclysm --
      jadeforest  = {6974,1},               hyjal        = {4868,1},
      valley      = {6974,2},               deepholm     = {4868,3},
      krasarang   = {6974,3},               uldum        = {4868,4},
      kunlai      = {6974,4},               twilight     = {4868,5},
      townlong    = {6974,5},             -- Northrend --
      dreadwastes = {6974,6},               howling      = {45,2},
      vale        = {6974,7},               dragonblight = {45,3},
  --[[Outland]]                             zuldrak      = {45,5},
      hellfire    = {44,1},                 crystalsong  = {45,7},
      zangarmarsh = {44,2},                 icecrown     = {45,9},
      nagrand     = {44,4},
      shadowmoon  = {44,7},
      shattrath   = {867,8},
  -- Kalimdor --                          -- Eastern Kingdoms --
      durotar      = {43,1},                elwynn       = {42,1},
      nbarrens     = {43,5},                burning      = {42,5},
      winterspring = {43,6},                duskwood     = {42,7},
      sbarrens     = {43,7},                redridge     = {42,10},
      ashenvale    = {43,10},               searing      = {42,13},
      thousand     = {43,11},               nstrang      = {42,16},
      stonetalon   = {43,12},               capestrang   = {42,17},
      desolace     = {43,13},               swamp        = {42,18},
      dustwallow   = {43,14},               hinterlands  = {42,19},
      feralas      = {43,15},               westfall     = {42,20},
      felwood      = {43,18},               deadwind     = {42,22},
      moonglade    = {43,20},               eplague      = {42,24} }
--------------------------------------------------------------------
local npcs = {
     -- Pandaria --                       -- Cataclysm --
      jadeforest  = {6974,1},               hyjal        = {7525,1},
      valley      = {6974,2},               deepholm     = {7525,2},
      krasarang   = {6974,3},
      kunlai      = {6974,4},               twilight     = {7525,3},
      townlong    = {6974,5},             -- Northrend --
      dreadwastes = {6974,6},               howling      = {6605,1},
      vale        = {6974,7},               dragonblight = {6605,3},
  --[[Outland]]                             zuldrak      = {6605,4},
      hellfire    = {6604,1},               crystalsong  = {6605,2},
      zangarmarsh = {6604,2},
      nagrand     = {6604,3},
      shattrath   = {6604,4},
  -- Kalimdor --                          -- Eastern Kingdoms --
      durotar      = {6602,1},               elwynn       = {6603,1},
      nbarrens     = {6602,2},               burning      = {6603,10},
                                             duskwood     = {6603,4},
      sbarrens     = {6602,8},               redridge     = {6603,3},
      ashenvale    = {6602,3},               searing      = {6603,9},
      thousand     = {6602,11},              nstrang      = {6603,5},
      stonetalon   = {6602,4},               capestrang   = {6603,6},
      desolace     = {6602,5},               swamp        = {6603,11},
      dustwallow   = {6602,9},               hinterlands  = {6603,7},
      feralas      = {6602,6},               westfall     = {6603,2},
      felwood      = {6602,10},
      moonglade    = {6602,7},               eplague      = {6603,8} }
--------------------------------------------------------------------
local levels = {
     -- Pandaria --                       -- Cataclysm --
      jadeforest  = 25,                     hyjal        = 25,
      valley      = 25,                     deepholm     = 25,
      krasarang   = 25,                     uldum        = 25,
      kunlai      = 25,                     twilight     = 25,
      townlong    = 25,                   -- Northrend --
      dreadwastes = 25,                     howling      = 25,
      vale        = 25,                     dragonblight = 25,
  --[[Outland]]                             zuldrak      = 25,
      hellfire    = 20,                     crystalsong  = 25,
      zangarmarsh = 21,                     icecrown     = 25,
      nagrand     = 22,
      shattrath   = 23,
      shadowmoon  = 24,
  -- Kalimdor --                          -- Eastern Kingdoms --
      durotar      = 2,                      elwynn       = 2,
      nbarrens     = 3,                      burning      = 17,
      winterspring = 19,                     duskwood     = 7,
      sbarrens     = 11,                     redridge     = 5,
      ashenvale    = 5,                      searing      = 15,
      thousand     = 15,                     nstrang      = 9,
      stonetalon   = 7,                      capestrang   = 11,
      desolace     = 9,                      swamp        = 16,
      dustwallow   = 14,                     hinterlands  = 13,
      feralas      = 13,                     westfall     = 3,
      felwood      = 16,                     deadwind     = 19,
      moonglade    = 17,                     eplague      = 14 }
--------------------------------------------------------------------
local icons = {
     -- Pandaria --                       -- Cataclysm --
      jadeforest  = pfwa..pfbe..pffl,       hyjal        = pfbe..pfcr..pfma,
      valley      = pfbe..pfel..pfel,       deepholm     = pfcr..pfel..pfel,
      krasarang   = pfwa..pfbe..pffl,       uldum        = pfbe..pfcr..pffl,
      kunlai      = pfbe..pfcr..pffl,       twilight     = pfbe..pfel..pfma,
      townlong    = pfwa..pfcr..pfel,     -- Northrend --
      dreadwastes = pfwa..pfbe..pfel,       howling      = pfwa..pffl..pffl,
      vale        = pfwa..pfcr..pfdr,       dragonblight = pfdr..pfun..pfun,
  --[[Outland]]                             zuldrak      = pfbe..pfbe..pfcr,
      hellfire    = pfme..pfme..pfme,       crystalsong  = pfun..pfun..pfun,
      zangarmarsh = pffl..pfhu..pfma,       icecrown     = pfbe..pfel..pfme,
      nagrand     = pfwa..pfbe..pfcr,
      shattrath   = pfwa..pfwa..pfwa,
      shadowmoon  = pfdr..pfel..pfma,
  -- Kalimdor --                          -- Eastern Kingdoms --
      durotar      = pfbe..pfcr,             elwynn       = pfbe..pfbe,
      nbarrens     = pfbe..pfbe..pfcr,       burning      = pfcr..pfel..pffl,
      winterspring = pfbe..pfdr..pffl,       duskwood     = pfbe..pfbe..pfbe,
      sbarrens     = pfme..pfme..pfme,       redridge     = pfcr..pfcr..pfcr,
      ashenvale    = pfwa..pfcr..pffl,       searing      = pfdr..pfdr..pfdr,
      thousand     = pfbe..pfcr..pfcr,       nstrang      = pfbe..pfbe..pfma,
      stonetalon   = pfbe..pfbe..pfcr,       capestrang   = pffl..pffl..pfhu,
      desolace     = pfwa..pfcr..pfel,       swamp        = pfwa..pfbe..pffl,
      dustwallow   = pfdr..pfdr..pfdr,       hinterlands  = pfbe..pfcr..pfma,
      feralas      = pfbe..pfcr..pfdr,       westfall     = pfcr..pffl..pfme,
      felwood      = pfma..pfma..pfme,       deadwind     = pfel..pfun..pfun,
      moonglade    = pfdr..pffl..pfma,       eplague      = pfbe..pfbe..pfun}
--------------------------------------------------------------------

local function getname(arg, color)
 if color then
  return AddColor(GetAchievementCriteriaInfo(arg[1],arg[2]), color)
 else
  return GetAchievementCriteriaInfo(arg[1],arg[2])
 end
end
------------------------------------------------------------------------
local function coord(questID)
 return AddColor(coordinates[questID],mainframecoordcolor)
end
------------------------------------------------------------------------
local function levelformat(lev)
 if lev > 100 then -- elite pets
  return AddColor("["..(lev - 100).."+] ", levelcolor)
 else
  return AddColor("["..lev.."] ", levelcolor)
 end
end
local function leveldeformat(arg)
 _,_,result = arg:find("(%d+)")
 return tonumber(result)
end
------------------------------------------------------------------------
local function getelitepetname(pet)
 local desc
 if tables[ONC] and ep_quest_index > -1 then
  desc,_,_ = GetQuestLogLeaderBoard(pet,ep_quest_index)
  if desc ~= nil then
   tables[ONC][ep_header][epspecial..pet].nameset = true
   return AddColor(desc,npcnamecolor)
  end
 end
end

-- elite pets icons
local function epicons(pet)
 if     pet == kawi then return pfcr
 elseif pet == gorespine then return pfbe
 elseif pet == nono then return pfwa
 elseif pet == greyhoof then return pfbe
 elseif pet == luckyyi then return pfcr
 elseif pet == tiun then return pfwa
 elseif pet == kafi then return pfbe
 elseif pet == dosryga then return pfwa
 elseif pet == nitun then return pfcr
 elseif pet == xia then return pfwa
 end
end
--[[
  dtc tables { zone name , npc name , coordinates, petslevel, petsicons }
]]--

 WEheader = EVENTS_LABEL
 WEtable = nil
 satchels_table = nil

-- I had to move the tables generation in the PLAYER_ENTERING_WORLD event
-- because as patch 5.2 came out the achievement criterias were not available
-- on login
local function GenerateTables()

 if WEtable == nil then
  WEtable = {}
  WEtable[CALENDAR_FILTER_DARKMOON] = { questID = 32175, name = "|TInterface\\icons\\INV_Misc_Eye_01:12|t "..AddColor(CALENDAR_FILTER_DARKMOON,mainframezonecolor),
                                       npcname = AddColor("(Jeremy Feasel)", mainframenpcnamecolor),
                                       level = levelformat(25), families = pfma..pfme..pfbe }
  -- future world event tamers here
 end
 
 ep_header = select(2,GetAchievementInfo(8080))

 if satchels_table == nil then
    satchels_table = {}
    satchels_table = { [select(2,GetAchievementInfo(7936))] = {
                  [32434] = {icon_firespirit..getname(zones.townlong,mainframezonecolor),
                             "",
                             coord(32434),
                             levelformat(25),
                             pfdr..pffl},-- townlong steppes
                  [32439] = {icon_waterspirit..getname(zones.dreadwastes,mainframezonecolor),
                             "",
                             coord(32439),
                             levelformat(25),
                             pfwa..pfcr}, -- dread wastes
                  [32441] = {icon_earthspirit..getname(zones.kunlai,mainframezonecolor),
                             "",
                             coord(32441),
                             levelformat(25),
                             pfcr..pfbe}, -- kun-lai
                  [32440] = {icon_airspirit..getname(zones.jadeforest,mainframezonecolor),
                             "",
                             coord(32440),
                             levelformat(25),
                             pfdr..pfcr}}, -- jade forest
               [select(2,GetAchievementInfo(6606))] = {
                  [31957] = {getname(zones.dreadwastes,mainframezonecolor),
                             AddColor(" (Shu)",mainframenpcnamecolor),                             
                             coord(31957),
                             levelformat(levels.dreadwastes),
                             icons.dreadwastes
                             },--dread wastes
                  [31991] = {getname(zones.townlong,mainframezonecolor),
                             AddColor(" (Zusshi)",mainframenpcnamecolor),
                             coord(31991),
                             levelformat(levels.townlong),
                             icons.townlong
                             },-- townlong
                  [31956] = {getname(zones.kunlai,mainframezonecolor),
                             AddColor(" (Yon)",mainframenpcnamecolor), 
                             coord(31956),
                             levelformat(levels.kunlai),
                             icons.kunlai
                             },-- kun-lai
                  [31955] = {getname(zones.valley,mainframezonecolor),
                             AddColor(" (Nishi)",mainframenpcnamecolor),
                             coord(31955),
                             levelformat(levels.valley),
                             icons.valley
                             },-- valley
                  [31954] = {getname(zones.krasarang,mainframezonecolor),
                             AddColor(" (Mo'ruk)",mainframenpcnamecolor),
                             coord(31954),
                             levelformat(levels.krasarang),
                             icons.krasarang
                             }, -- krasarang
                  [31953] = {getname(zones.jadeforest,mainframezonecolor),
                             AddColor(" (Hyuna)",mainframenpcnamecolor),
                             coord(31953),
                             levelformat(levels.jadeforest),
                             icons.jadeforest
                             },-- jade forest
                  [31958] = {getname(zones.vale,mainframezonecolor),
                             AddColor(" (Aki)",mainframenpcnamecolor),
                             coord(31958),
                             levelformat(levels.vale),
                             icons.vale
                             } }, -- vale
               [select(2,GetAchievementInfo(6607))] = {
                  [31935] = {getname(zones.icecrown,mainframezonecolor),
                            AddColor(" (Payne)",mainframenpcnamecolor),
                            coord(31935),
                            levelformat(levels.icecrown),
                            icons.icecrown
                            }, --icecrown
                  [31926] = {getname(zones.shadowmoon,mainframezonecolor),
                            AddColor(" (Antari)",mainframenpcnamecolor), 
                            coord(31926),
                            levelformat(levels.shadowmoon),
                            icons.shadowmoon
                            }, --shadowmoon
                  [31916] = {getname(zones.deadwind,mainframezonecolor),
                            AddColor(" (Lydia)",mainframenpcnamecolor),
                            coord(31916),
                            levelformat(levels.deadwind),
                            icons.deadwind
                            }, -- deadwind pass
                  [31909] = {getname(zones.winterspring,mainframezonecolor),
                            AddColor(" (Trixxy)",mainframenpcnamecolor), 
                            coord(31909),
                            levelformat(levels.winterspring),
                            icons.winterspring
                            },-- winterspring
                  [31971] = {getname(zones.uldum,mainframezonecolor),
                            AddColor(" (Obalis)",mainframenpcnamecolor),
                            coord(31971),
                            levelformat(levels.uldum),
                            icons.uldum
                            } } }-- uldum

 tables[ONC] = { [select(2,GetAchievementInfo(6604))] = { -- outlands
                  [31923] = {getname(zones.zangarmarsh,zonecolor),
                            getname(npcs.zangarmarsh,npcnamecolor),
                            coord(31923),
                            levelformat(levels.zangarmarsh),
                            icons.zangarmarsh}, -- zangarmarsh
                  [31925] = {getname(zones.shattrath,zonecolor),
                            getname(npcs.shattrath,npcnamecolor), 
                            coord(31925),
                            levelformat(levels.shattrath),
                            icons.shattrath},-- shattrath
                  [31924] = {getname(zones.nagrand,zonecolor),
                            getname(npcs.nagrand,npcnamecolor), 
                            coord(31924),
                            levelformat(levels.nagrand),
                            icons.nagrand},--nagrand
                  [31922] = {getname(zones.hellfire,zonecolor),
                            getname(npcs.hellfire,npcnamecolor), 
                            coord(31922),
                            levelformat(levels.hellfire),
                            icons.hellfire} },--hellfire
               [select(2,GetAchievementInfo(6605))] = {
                  [31931] = {getname(zones.howling,zonecolor),
                            getname(npcs.howling,npcnamecolor), 
                            coord(31931),
                            levelformat(levels.howling),
                            icons.howling},--howling fjord
                  [31934] = {getname(zones.zuldrak,zonecolor),
                            getname(npcs.zuldrak,npcnamecolor), 
                            coord(31934),
                            levelformat(levels.zuldrak),
                            icons.zuldrak},--zul drak
                  [31932] = {getname(zones.crystalsong,zonecolor),
                            getname(npcs.crystalsong,npcnamecolor), 
                            coord(31932),
                            levelformat(levels.crystalsong),
                            icons.crystalsong},--crystalsong
                  [31933] = {getname(zones.dragonblight,zonecolor),
                            getname(npcs.dragonblight,npcnamecolor),
                            coord(31933),
                            levelformat(levels.dragonblight),
                            icons.dragonblight} }, --dragonblight
               [select(2,GetAchievementInfo(7525))] = {
                  [31973] = {getname(zones.deepholm,zonecolor),
                            getname(npcs.deepholm,npcnamecolor),
                            coord(31973),
                            levelformat(levels.deepholm),
                            icons.deepholm},--deepholm
                  [31972] = {getname(zones.hyjal,zonecolor),
                            getname(npcs.hyjal,npcnamecolor),
                            coord(31972),
                            levelformat(levels.hyjal),
                            icons.hyjal},--mount hyjal
                  [31974] = {getname(zones.twilight,zonecolor),
                            getname(npcs.twilight,npcnamecolor),
                            coord(31974),
                            levelformat(levels.twilight),
                            icons.twilight} },
--------------------------------------------------------------------
               -- Elite Pets             
                [ep_header] = {
                  [epspecial..kawi] = {getname(zones.jadeforest,zonecolor),
                            "",
                            coord(epspecial..kawi),
                            levelformat(125),
                            epicons(kawi)},--kawi elite pet
                  [epspecial..gorespine] = {getname(zones.dreadwastes,zonecolor),
                            "",
                            coord(epspecial..gorespine),
                            levelformat(125),
                            epicons(gorespine)},--gorespine elite pet
                  [epspecial..nono] = {getname(zones.vale,zonecolor),
                            "",
                            coord(epspecial..nono),
                            levelformat(125),
                            epicons(nono)},--nono elite pet
                  [epspecial..greyhoof] = {getname(zones.valley,zonecolor),
                            "",
                            coord(epspecial..greyhoof),
                            levelformat(125),
                            epicons(greyhoof)},--greyhoof elite pet
                  [epspecial..luckyyi] = {getname(zones.valley,zonecolor),
                            "",
                            coord(epspecial..luckyyi),
                            levelformat(125),
                            epicons(luckyyi)},--luckyyi elite pet
                  [epspecial..tiun] = {getname(zones.townlong,zonecolor),
                            "",
                            coord(epspecial..tiun),
                            levelformat(125),
                            epicons(tiun)},--tiun elite pet
                  [epspecial..kafi] = {getname(zones.kunlai,zonecolor),
                            "",
                            coord(epspecial..kafi),
                            levelformat(125),
                            epicons(kafi)},--kafi elite pet
                  [epspecial..dosryga] = {getname(zones.kunlai,zonecolor),
                            "",
                            coord(epspecial..dosryga),
                            levelformat(125),
                            epicons(dosryga)},--dosryga elite pet
                  [epspecial..nitun] = {getname(zones.jadeforest,zonecolor),
                            "",
                            coord(epspecial..nitun),
                            levelformat(125),
                            epicons(nitun)},--nitun elite pet
                  [epspecial..xia] = {getname(zones.krasarang,zonecolor),
                            "",
                            coord(epspecial..xia),
                            levelformat(125),
                            epicons(xia)},--xia elite pet
                            }, }

tables[EKK] = { [select(2,GetAchievementInfo(6602)).." ("..FACTION_HORDE..")"] = { -- horde only (kalimdor)
                  [31854] = {getname(zones.ashenvale,zonecolor),
                             getname(npcs.ashenvale,npcnamecolor),
                             coord(31854),
                            levelformat(levels.ashenvale),
                            icons.ashenvale},--ashenvale
                  [31904] = {getname(zones.sbarrens,zonecolor),
                             getname(npcs.sbarrens,npcnamecolor),
                             coord(31904),
                            levelformat(levels.sbarrens),
                            icons.sbarrens},--southern barrens
                  [31819] = {getname(zones.nbarrens,zonecolor),
                             getname(npcs.nbarrens,npcnamecolor),
                             coord(31819),
                            levelformat(levels.nbarrens),
                            icons.nbarrens},--northern barrens
                  [31908] = {getname(zones.moonglade,zonecolor),
                             getname(npcs.moonglade,npcnamecolor),
                             coord(31908),
                            levelformat(levels.moonglade),
                            icons.moonglade},--moonglade
                  [31905] = {getname(zones.dustwallow,zonecolor),
                             getname(npcs.dustwallow,npcnamecolor),
                             coord(31905),
                            levelformat(levels.dustwallow),
                            icons.dustwallow},--dustwallow marsh
                  [31906] = {getname(zones.thousand,zonecolor),
                             getname(npcs.thousand,npcnamecolor),
                             coord(31906),
                            levelformat(levels.thousand),
                            icons.thousand},--thousand needles
                  [31872] = {getname(zones.desolace,zonecolor),
                             getname(npcs.desolace,npcnamecolor),
                             coord(31872),
                            levelformat(levels.desolace),
                            icons.desolace},--desolace
                  [31871] = {getname(zones.feralas,zonecolor),
                             getname(npcs.feralas,npcnamecolor),
                             coord(31871),
                            levelformat(levels.feralas),
                            icons.feralas},--feralas
                  [31907] = {getname(zones.felwood,zonecolor),
                             getname(npcs.felwood,npcnamecolor),
                             coord(31907),
                            levelformat(levels.felwood),
                            icons.felwood},--felwood
                  [31862] = {getname(zones.stonetalon,zonecolor),
                             getname(npcs.stonetalon,npcnamecolor),
                             coord(31862),
                            levelformat(levels.stonetalon),
                            icons.stonetalon}, --stonetalon
                  [31818] = {getname(zones.durotar,zonecolor),
                             getname(npcs.durotar,npcnamecolor),
                             coord(31818),
                            levelformat(levels.durotar),
                            icons.durotar} },--durotar
                        [select(2,GetAchievementInfo(6603)).." ("..FACTION_ALLIANCE..")"] = { -- alliance only (eastern kingdoms)
                  [31851] = {getname(zones.capestrang,zonecolor),
                             getname(npcs.capestrang,npcnamecolor),
                             coord(31851),
                            levelformat(levels.capestrang),
                            icons.capestrang},--cape of stranglethorn
                  [31910] = {getname(zones.hinterlands,zonecolor),
                             getname(npcs.hinterlands,npcnamecolor),
                             coord(31910),
                            levelformat(levels.hinterlands),
                            icons.hinterlands},--hinterlands
                  [31911] = {getname(zones.eplague,zonecolor),
                             getname(npcs.eplague,npcnamecolor),
                             coord(31911),
                            levelformat(levels.eplague),
                            icons.eplague},--eastern plaguelands
                  [31914] = {getname(zones.burning,zonecolor),
                             getname(npcs.burning,npcnamecolor),
                             coord(31914),
                            levelformat(levels.burning),
                            icons.burning}, --burning steppes
                  [31850] = {getname(zones.duskwood,zonecolor),
                             getname(npcs.duskwood,npcnamecolor),
                             coord(31850),
                            levelformat(levels.duskwood),
                            icons.duskwood},--duskwood
                  [31913] = {getname(zones.swamp,zonecolor),
                             getname(npcs.swamp,npcnamecolor),
                             coord(31913),
                            levelformat(levels.swamp),
                            icons.swamp},--swamp of sorrows
                  [31693] = {getname(zones.elwynn,zonecolor),
                             getname(npcs.elwynn,npcnamecolor),
                             coord(31693),
                            levelformat(levels.elwynn),
                            icons.elwynn}, --elwynn forest
                  [31912] = {getname(zones.searing,zonecolor),
                             getname(npcs.searing,npcnamecolor),
                             coord(31912),
                            levelformat(levels.searing),
                            icons.searing},--searing gorge
                  [31781] = {getname(zones.redridge,zonecolor),
                             getname(npcs.redridge,npcnamecolor),
                             coord(31781),
                            levelformat(levels.redridge),
                            icons.redridge},--redridge mountains
                  [31780] = {getname(zones.westfall,zonecolor),
                             getname(npcs.westfall,npcnamecolor),
                             coord(31780),
                            levelformat(levels.westfall),
                            icons.westfall},--westfall
                  [31852] = {getname(zones.nstrang,zonecolor),
                             getname(npcs.nstrang,npcnamecolor),
                             coord(31852),
                            levelformat(levels.nstrang),
                            icons.nstrang} } }--northern stranglethorn
 end
end

local ZONE = 1 NPCNAME = 2 COORDS = 3 NPCLEVEL = 4 NPCICONS = 5

-- check for active world events
local function AddWorldEventTamers()
 local i
 local _,_,today = CalendarGetDate()
 for i = 1,CalendarGetNumDayEvents(0,today) do
  local title = CalendarGetDayEvent(0, today, i)
  table.foreach(WEtable,function(k,v)
  if title == k then
    if not satchels_table[WEheader] then satchels_table[WEheader] = {} end
    satchels_table[WEheader][v.questID] = {v.name, "", "", v.level, v.families}
   end
  end)
 end
 --worldeventschecked = true
end

local function GenerateLine(info)
    local s1 = "";
    -- npc level
    if DailyTamerCheck_Options["show_npclevel"] and info[NPCLEVEL] then
     s1 = s1..info[NPCLEVEL]
    end
    -- npc pets
    if DailyTamerCheck_Options["show_npcicons"] and info[NPCICONS] then
     s1 = s1..info[NPCICONS].." "
    end
    -- zone name
    if info[ZONE] then
     s1 = s1..info[ZONE]
    else 
     s1 = s1.."<zone missing>"
    end
    -- npc name
    if DailyTamerCheck_Options["show_npcnames"] and info[NPCNAME] then
     s1 = s1.." "..info[NPCNAME]
    end
    -- coordinates
    if DailyTamerCheck_Options["show_coordinates"] and info[COORDS] then
     s1 = s1.." "..info[COORDS]
    end
    return s1
end

--sorting by level
local function foreachinorder(t,f)
 local keys = {}
 for k,_ in pairs(t) do
     keys[#keys+1] = k
 end
 table.sort(keys,function (a,b)
   if (t[a][NPCLEVEL] and t[b][NPCLEVEL]) then
    -- we need integer values to compare
    return leveldeformat(t[a][NPCLEVEL]) < leveldeformat(t[b][NPCLEVEL])
   else
    return a < b
   end
  end)
 for _,k in ipairs(keys) do
  f(k,t[k])
 end
end

-- main "tooltip template" frame
local function DrawTCheckMainframe(obj, tab, istooltip)

 --if not worldeventschecked then
 AddWorldEventTamers()
 --end

 obj:ClearLines()
 obj:AddDoubleLine("Daily Tamer Check","|T"..dtcicon..":32|t")
 local s1,s2
  table.foreach(tab,function(k,v)
  --min width
   obj:AddLine("                                                      ")
   obj:AddLine(k)
   
   if (DailyTamerCheck_Options["show_npclevel"]) then       
     --sorting by level
        foreachinorder(v,
            function(questID,info)
            -- right text
            if IsQuestFlaggedCompleted(questID) then 
                s2 = AddColor(COMPLETE,LIGHT_GREEN)
            else
                s2 = AddColor(INCOMPLETE,LIGHT_RED)
            end
    
            s1 = GenerateLine(info)
    
            obj:AddDoubleLine(s1,s2)
        end)
      else -- normal sorting
        table.foreach(v,
            function(questID,info)
            -- right text
            if IsQuestFlaggedCompleted(questID) then 
                s2 = AddColor(COMPLETE,LIGHT_GREEN)
            else
                s2 = AddColor(INCOMPLETE,LIGHT_RED)
            end

            s1 = GenerateLine(info)
    
            obj:AddDoubleLine(s1,s2)
        end)
      end
  end)
  if not istooltip then
  -- create some space for the bottom buttons
   obj:AddLine(" ")
   obj:AddLine(" ")
   obj:AddLine(" ")
  end
end

-- lateral frames
local function DrawTCheckFrame(obj, tab)
 local s1,s2
 local tmpleft  = ""
 local tmpright = ""
 obj.maxwidth = 1
  
 local function adddoubleline(left,right)
  tmpleft  = tmpleft.."\n"..left
  tmpright = tmpright.."\n"..right
  
  local lefttmp
  lefttmp = string.gsub(left,"|c........","")
  lefttmp = string.gsub(lefttmp,"|r","")
  obj.leftfont:SetText(lefttmp..right)
  local tmplen = obj.leftfont:GetStringWidth(obj.leftfont)+40
  if (tmplen > obj.maxwidth) then
   obj.maxwidth = tmplen
  end
 end

  local epquest_completed = false
  local epquest_missing = false
  
  table.foreach(tab,function(k,v)
   adddoubleline("","")
   if k == ep_header then -- elite pets special
    if IsQuestFlaggedCompleted(32604) then
     s2 = AddColor(COMPLETE,LIGHT_GREEN)
     epquest_completed = true
    else
     s2 = AddColor(INCOMPLETE,LIGHT_RED)
    end
    if ep_quest_name ~= "" then
     adddoubleline(AddColor(ep_quest_name,GOLD).." "..s2,"")
    else
     adddoubleline(AddColor(k,GOLD).." "..s2,"")
    end
   else
    adddoubleline(AddColor(k,GOLD),"")
   end
   
    if (DailyTamerCheck_Options["show_npclevel"]) then       
     --sorting by level
        foreachinorder(v,
          function(questID,info)
       -- elite pets special (a single quest for 10 pets.. meh)
            if tostring(questID):find(epspecial) then
             if not epquest_completed and ep_quest_index > -1 then
              local epindex = string.gsub(tostring(questID), epspecial, "")
              local _,_,done = GetQuestLogLeaderBoard(tonumber(epindex),ep_quest_index)
              if done then
               s2 = AddColor(COMPLETE,LIGHT_GREEN)
              else
               s2 = AddColor(INCOMPLETE,LIGHT_RED)
              end
              s1 = GenerateLine(info)
              adddoubleline(s1,s2)
             elseif ep_quest_index == -1 and not epquest_completed and not epquest_missing then
              epquest_missing = true
              adddoubleline(ep_quest_missing,"")
             end
            else
        -- right text
             if IsQuestFlaggedCompleted(questID) then 
                s2 = AddColor(COMPLETE,LIGHT_GREEN)
             else
                s2 = AddColor(INCOMPLETE,LIGHT_RED)
             end
             s1 = GenerateLine(info)
             adddoubleline(s1,s2)
            end
         end)        
    else -- normal sorting
        table.foreach(v,
            function(questID,info)
       -- elite pets special (a single quest for 10 pets.. meh)
            if tostring(questID):find(epspecial) then
             if not epquest_completed and ep_quest_index > -1 then
              local epindex = string.gsub(tostring(questID), epspecial, "")
              local _,_,done = GetQuestLogLeaderBoard(tonumber(epindex),ep_quest_index)
              if done then
               s2 = AddColor(COMPLETE,LIGHT_GREEN)
              else
               s2 = AddColor(INCOMPLETE,LIGHT_RED)
              end
              s1 = GenerateLine(info)
              adddoubleline(s1,s2)
             elseif ep_quest_index == -1 and not epquest_completed and not epquest_missing then
              epquest_missing = true
              adddoubleline(ep_quest_missing,"")
             end
            else
        -- right text
             if IsQuestFlaggedCompleted(questID) then
                s2 = AddColor(COMPLETE,LIGHT_GREEN)
             else
                s2 = AddColor(INCOMPLETE,LIGHT_RED)
             end
             s1 = GenerateLine(info)
             adddoubleline(s1,s2)
            end
        end)
    end
   end)

 obj.leftfont:SetText(tmpleft)
 obj.rightfont:SetText(tmpright)
end

local function CheckFramesAnimation(frame,id)
 if (frame) and (frame:IsVisible()) and (frame.maxwidth ~= nil) and (frame.width ~= nil) and (frame.opening ~= nil) then
  if frame.opening then
   if frame.width < frame.maxwidth then
    frame.width = frame.width + opt_framespeed
    if id == ABOUT then
     frame:SetHeight(frame.width)
    else
     frame:SetWidth(frame.width)
    end
   elseif (not frame.leftfont:IsVisible()) then
    frame.leftfont:Show()
    frame.rightfont:Show()
   end
  else -- closing
   if frame.width > opt_framespeed then
    frame.width = frame.width - opt_framespeed
    if id == ABOUT then
     frame:SetHeight(frame.width)
    else
     frame:SetWidth(frame.width)
    end
    if (frame.leftfont:IsVisible()) then
     frame.leftfont:Hide()
     frame.rightfont:Hide()
    end
   else
    frame:Hide()
   end
  end
 end
end

local function OnOptionChanged(opt)

end

local ID_MINIMAP_SPECIAL = 99
local function CreateCheckbox(parent,id,option,mo_tooltip,tx,offsetX,offsetY)

 local chkbox

 local function setcheckboxtexture(flag)
  local shaderSupported = chkbox.texture:SetDesaturated(not flag);
  if not shaderSupported then
   if not flag then
     chkbox.texture:SetVertexColor(0.5, 0.5, 0.5);
   else
     chkbox.texture:SetVertexColor(1.0, 1.0, 1.0);
   end
  end
 end

  if not parent.checkbox[id] then
   chkbox = CreateFrame("FRAME", nil, parent.optionsframe)
   chkbox.texture = chkbox:CreateTexture()
  else 
   chkbox = parent.checkbox[id]
  end

  chkbox:SetPoint("CENTER", parent.optionsframe, "CENTER",offsetX,offsetY)
  --chkbox:SetFrameStrata("HIGH")
  chkbox:SetWidth(20)
  chkbox:SetHeight(20)
  chkbox.texture:SetPoint("LEFT", chkbox, "LEFT")
  chkbox.texture:SetTexture(tx)
  chkbox.texture:SetWidth(20)
  chkbox.texture:SetHeight(20)
  if (id == ID_MINIMAP_SPECIAL) then
   setcheckboxtexture(not DailyTamerCheck_Options["minimap_icon"].hide)
  else
   setcheckboxtexture(DailyTamerCheck_Options[option])
  end

  chkbox:SetScript("OnMouseUp", function(self)
   if (id == ID_MINIMAP_SPECIAL) then -- it's pretty rough.. I know :p
    DailyTamerCheck_Options["minimap_icon"].hide = not DailyTamerCheck_Options["minimap_icon"].hide;
    ldbicon:Refresh("DailyTamerCheck", DailyTamerCheck, DailyTamerCheck_Options["minimap_icon"])
    setcheckboxtexture(not DailyTamerCheck_Options["minimap_icon"].hide)
   else
    DailyTamerCheck_Options[option] = not DailyTamerCheck_Options[option]
    OnOptionChanged(option)
    DrawTCheckMainframe(DailyTamerCheck_mainframe,satchels_table,false)
    setcheckboxtexture(DailyTamerCheck_Options[option])
    DailyTamerCheck_mainframe:Show()
   end
  end)
  
  chkbox:SetScript("OnEnter", function(self)
   GameTooltip:SetOwner(chkbox,"ANCHOR_BOTTOM",0,-5)
   GameTooltip:ClearLines()
   GameTooltip:AddLine(mo_tooltip)
   GameTooltip:Show()
  end)  

  chkbox:SetScript("OnLeave", function(self)
   GameTooltip:Hide()
  end)
  
  parent.checkbox[id] = chkbox
  chkbox:Hide()
end --CreateCheckBox

local function CreateNewFrameButton(id,pos,tx)
local result, button
 if not DailyTamerCheck_mainframe.buttons[id] then
  button = CreateFrame("FRAME", nil, DailyTamerCheck_mainframe)
 else button = DailyTamerCheck_mainframe.buttons[id]
 end
 if not button.texture then
  button.texture = button:CreateTexture()
 end
 if not DailyTamerCheck_mainframe.frames[id] then
  result = CreateFrame("FRAME")
 else result = DailyTamerCheck_mainframe.frames[id]
 end
 if not result.texture then
  result.texture = result:CreateTexture()
 end
 result.texture:SetAllPoints()
 result.texture:SetTexture(0,0,0,0.7)
 if not result.leftfont then
  result.leftfont = result:CreateFontString(nil, "OVERLAY", "GameTooltipText")
 end
 result.leftfont:SetParent(result)
 result.leftfont:SetPoint("TOPLEFT",10,-10)
 if not result.rightfont then
  result.rightfont = result:CreateFontString(nil, "OVERLAY", "GameTooltipText")
 end
 result.rightfont:SetParent(result)
 result.rightfont:SetPoint("TOPRIGHT",-10,-10)
 result.width = 1
 if id == ABOUT then
   result.leftfont:SetText(AddColor(" Daily Tamer Check ",GOLD).."\n"..
                                         AddColor(" by\n",GREY)..
                                         AddColor(" Fluffies",LIGHT_BLUE)..
                                         AddColor(" EU-Well of Eternity",GREY))
   result.rightfont:SetText("|T"..dtcicon..":24|t\n")
   result.maxwidth = 60
  else
   result.maxwidth = 200
  end

 result.leftfont:Hide()
 result.rightfont:Hide()

 result:SetFrameStrata("DIALOG")
 result:SetScale(0.9)
 result:SetClampedToScreen(true)
 result:ClearAllPoints()
 if pos == "left" then
  result:SetPoint("TOPRIGHT", DailyTamerCheck_mainframe, "TOPLEFT")
  result:SetPoint("BOTTOMRIGHT", DailyTamerCheck_mainframe, "BOTTOMLEFT")
 elseif pos == "right" then
  result:SetPoint("TOPLEFT", DailyTamerCheck_mainframe, "TOPRIGHT")
  result:SetPoint("BOTTOMLEFT", DailyTamerCheck_mainframe, "BOTTOMRIGHT")
 elseif pos == "bottomright" or pos == "bottomleft" then
  result:SetPoint("TOPLEFT", DailyTamerCheck_mainframe, "BOTTOMLEFT")
  result:SetPoint("TOPRIGHT", DailyTamerCheck_mainframe, "BOTTOMRIGHT")
 end
 -- frame's opening/closing animation
 result:SetScript("OnUpdate", function(self)
   CheckFramesAnimation(result,id)
  end)

  if pos == "left" then
   button:SetPoint("BOTTOMLEFT", DailyTamerCheck_mainframe, "BOTTOMLEFT",10,10)
  elseif pos == "right" then
   button:SetPoint("BOTTOMRIGHT", DailyTamerCheck_mainframe, "BOTTOMRIGHT",-10,10)
  elseif pos == "bottomright" then
   button:SetPoint("BOTTOM", DailyTamerCheck_mainframe, "BOTTOM",centerbuttons_spacing,10)
  elseif pos == "bottomleft" then
   button:SetPoint("BOTTOMLEFT", DailyTamerCheck_mainframe, "BOTTOMLEFT",45,10)
  end
  button:SetWidth(25)
  button:SetHeight(25)
  button.texture:SetAllPoints()
  button.texture:SetTexture(tx)

  button:SetScript("OnEnter", function(self)
  result.opening = true
  result:SetWidth(result.width)
  if id == EKK or id == ONC then
   DrawTCheckFrame(result,tables[id])
  end
  result:Show()
 end)

  button:SetScript("OnLeave", function(self)
   if result then 
    result.opening = false 
   end
  end)

 button:Show()
 if result.opening then result:Show() else result:Hide() end
 DailyTamerCheck_mainframe.frames[id] = result;
 DailyTamerCheck_mainframe.buttons[id] = button;
end --CreateNewFrameButton

local function tamerquestcheck()
if DailyTamerCheck_mainframe and DailyTamerCheck_mainframe:IsVisible() then
 DailyTamerCheck_mainframe:Hide()
else
  if not DailyTamerCheck_mainframe then
   DailyTamerCheck_mainframe = CreateFrame("GameTooltip", "DailyTamerCheck_mainframe", nil, "GameTooltipTemplate")
  end
  
  DailyTamerCheck_mainframe:SetOwner(UIParent,"ANCHOR_NONE")
  DailyTamerCheck_mainframe:SetPoint("CENTER",UIParent,"CENTER")
  DailyTamerCheck_mainframe:SetFrameStrata("HIGH")
  DailyTamerCheck_mainframe:EnableMouse(true)
  DailyTamerCheck_mainframe:SetMovable()
  DailyTamerCheck_mainframe:SetScale(0.9)
  DailyTamerCheck_mainframe:RegisterForDrag("LeftButton")
  DailyTamerCheck_mainframe:SetScript("OnDragStart", function(self)  
		self:StartMoving()
  end)
  DailyTamerCheck_mainframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
  end)

  if not DailyTamerCheck_mainframe.buttons then
   DailyTamerCheck_mainframe.buttons  = {}
  end
  if not DailyTamerCheck_mainframe.frames then
   DailyTamerCheck_mainframe.frames = {}
  end
  CreateNewFrameButton(EKK,"left",tx_btnkalim)
  CreateNewFrameButton(ONC,"right",tx_btnnorth)
  CreateNewFrameButton(ABOUT,"bottomright",tx_btnabout)
  
   -- options' checkboxes
   if not DailyTamerCheck_mainframe.optionsframe then
    DailyTamerCheck_mainframe.optionsframe = CreateFrame("FRAME", nil, DailyTamerCheck_mainframe)
    DailyTamerCheck_mainframe.optionsframe.texture = DailyTamerCheck_mainframe.optionsframe:CreateTexture()
    --DailyTamerCheck_mainframe.optionsframe:SetPoint("BOTTOMLEFT", DailyTamerCheck_mainframe, "BOTTOMLEFT",45,10)
    DailyTamerCheck_mainframe.optionsframe:SetPoint("BOTTOM",DailyTamerCheck_mainframe,"BOTTOM",-centerbuttons_spacing,10)
    DailyTamerCheck_mainframe.optionsframe:SetWidth(25)
    DailyTamerCheck_mainframe.optionsframe:SetHeight(25)
    DailyTamerCheck_mainframe.optionsframe.texture:SetPoint("CENTER",DailyTamerCheck_mainframe.optionsframe,"CENTER")
    DailyTamerCheck_mainframe.optionsframe.texture:SetAllPoints()
    DailyTamerCheck_mainframe.optionsframe.texture:SetTexture(tx_optionsframe)
    DailyTamerCheck_mainframe.optionsframe:SetScript("OnLeave", function(self)
     GameTooltip:Hide()  
    end)
    DailyTamerCheck_mainframe.optionsframe:SetScript("OnEnter", function(self)
     GameTooltip:SetOwner(DailyTamerCheck_mainframe.optionsframe,"ANCHOR_TOP",0,5)
     GameTooltip:ClearLines()
     GameTooltip:AddLine(s_optionsmain)
     GameTooltip:Show()
    end)
    
    DailyTamerCheck_mainframe.optionsframe:SetScript("OnMouseUp", function(self)
     if not DailyTamerCheck_mainframe.optionsframe.open then
      table.foreach(DailyTamerCheck_mainframe.checkbox, function(k,v) if not v:IsVisible() then v:Show() end end)
      DailyTamerCheck_mainframe.optionsframe.open = true;
      DailyTamerCheck_mainframe.optionsframe.texture:SetVertexColor(0.5,1,0.5,1)
     else
      table.foreach(DailyTamerCheck_mainframe.checkbox, function(k,v) if v:IsVisible() then v:Hide() end end)
      DailyTamerCheck_mainframe.optionsframe.open = false;
      DailyTamerCheck_mainframe.optionsframe.texture:SetVertexColor(1,1,1,1)
     end
    end)
   end
   DailyTamerCheck_mainframe.optionsframe.texture:SetVertexColor(1,1,1,1)
   DailyTamerCheck_mainframe.optionsframe.open = false;
   if not DailyTamerCheck_mainframe.checkbox then DailyTamerCheck_mainframe.checkbox = {} end
   CreateCheckbox(DailyTamerCheck_mainframe,0,"show_coordinates",
                         s_togglecoords,tx_chkcoords,-20,-25)
   CreateCheckbox(DailyTamerCheck_mainframe,1,"show_npcnames",
                         s_togglenpcnames,tx_chknames,0,-25)
CreateCheckbox(DailyTamerCheck_mainframe,2,"show_npclevel",
                         s_togglenpclevel,tx_chklevel,40,-25)
CreateCheckbox(DailyTamerCheck_mainframe,3,"show_npcicons",
                         s_togglenpcicons,tx_chkicons,-40,-25)
   CreateCheckbox(DailyTamerCheck_mainframe,ID_MINIMAP_SPECIAL,"",
                         s_toggleminimapbtn,tx_chkminimap,20,-25)

 DrawTCheckMainframe(DailyTamerCheck_mainframe,satchels_table,false)

 if not btnclose then
  btnclose = CreateFrame("Button", "dtcclosebtn", DailyTamerCheck_mainframe, "UIPanelButtonTemplate")
  btnclose:SetPoint("BOTTOM", DailyTamerCheck_mainframe, "BOTTOM",0,10)
  btnclose:SetWidth(100)
  btnclose:SetText(CLOSE)
  btnclose:SetScript("OnClick", function(self)
  if DailyTamerCheck_mainframe.frames then
   table.foreach(DailyTamerCheck_mainframe.frames,function(k,v) v:Hide() end)
  end
  DailyTamerCheck_mainframe:Hide()
  collectgarbage()
 end)

 end
 DailyTamerCheck_mainframe:Show()
end
end

local eventframe = CreateFrame("FRAME","DTCEventFrame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD")
eventframe:RegisterEvent("VARIABLES_LOADED")
eventframe:RegisterEvent("QUEST_LOG_UPDATE")
local function eventhandler(self, event, ...)

 if event == "QUEST_LOG_UPDATE" then
  local i, j, s
  ep_quest_index = -1
  for i = 1, GetNumQuestLogEntries() do
   s = GetQuestLink(i)
   if s ~= nil and string.match(s, "Hquest:(%d+)") == "32604" then
    ep_quest_index = i
    ep_quest_name = select(1,GetQuestLogTitle(ep_quest_index))
    if not epnamesset then
     for j = 1, ep_totalpets do
      if tables[ONC] and not tables[ONC][ep_header][epspecial..j].nameset then
       tables[ONC][ep_header][epspecial..j][NPCNAME] = getelitepetname(j)
      end
     end
    end
    break
   end
  end
 elseif event == "PLAYER_ENTERING_WORLD" then
  OpenCalendar()
  GenerateTables()
  --eventframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
 elseif event == "VARIABLES_LOADED" then
  if DailyTamerCheck_Options == nil then
   DailyTamerCheck_Options = {}
  end
  if DailyTamerCheck_Options["show_coordinates"] == nil then
   DailyTamerCheck_Options["show_coordinates"] = false
  end
  if DailyTamerCheck_Options["show_npcnames"] == nil then
   DailyTamerCheck_Options["show_npcnames"] = false
  end
  if DailyTamerCheck_Options["show_npclevel"] == nil then
   DailyTamerCheck_Options["show_npclevel"] = false
  end
  if DailyTamerCheck_Options["show_npcicons"] == nil then
   DailyTamerCheck_Options["show_npcicons"] = false
  end
  if DailyTamerCheck_Options["minimap_icon"] == nil then
    DailyTamerCheck_Options["minimap_icon"] = {
        hide = false,
        minimapPos = 220,
    }
  end
  

if ldb then
 local DailyTamerCheck = ldb:NewDataObject("DailyTamerCheck", {
	type = "data source",
	icon = dtcicon,
	label = "Daily Tamer Check",
	OnClick = function(self,button)
         tamerquestcheck()
	end,
	OnTooltipShow = function(tooltip)
		 DrawTCheckMainframe(tooltip,satchels_table,true)
	end,
 })
 if ldbicon then
  ldbicon:Register("DailyTamerCheck", DailyTamerCheck, DailyTamerCheck_Options["minimap_icon"])
 end
end

  
 end
end
eventframe:SetScript("OnEvent", eventhandler);

-- slash command
SLASH_DAILYTAMERCHECK1 = "/dtcheck"
SLASH_DAILYTAMERCHECK2 = "/dtc"
SlashCmdList["DAILYTAMERCHECK"] = tamerquestcheck